INCLUDE (CheckIncludeFiles)

FIND_PATH(LIBTORRENT_INCLUDE_DIR libtorrent/session.hpp)
MARK_AS_ADVANCED(LIBTORRENT_INCLUDE_DIR)

FIND_LIBRARY(LIBTORRENT_LIBRARY torrent)
MARK_AS_ADVANCED(LIBTORRENT_LIBRARY)

IF(LIBTORRENT_INCLUDE_DIR AND LIBTORRENT_LIBRARY)
  SET(LIBTORRENT_FOUND 1)
  SET(LIBTORRENT_LIBRARIES ${LIBTORRENT_LIBRARY})
  SET(LIBTORRENT_INCLUDE_DIRS ${LIBTORRENT_INCLUDE_DIR}/libtorrent)
ELSE(LIBTORRENT_INCLUDE_DIR AND LIBTORRENT_LIBRARY)
  SET(LIBTORRENT_FOUND 0)
  SET(LIBTORRENT_LIBRARIES)
  SET(LIBTORRENT_INCLUDE_DIRS)
ENDIF(LIBTORRENT_INCLUDE_DIR AND LIBTORRENT_LIBRARY)

IF(NOT LIBTORRENT_FOUND)
  SET(LIBTORRENT_DIR_MESSAGE
      "LIBTORRENT was not found. Make sure LIBTORRENT_LIBRARY and LIBTORRENT_INCLUDE_DIR are set.")
  IF(NOT LIBTORRENT_FIND_QUIETLY)
    MESSAGE(STATUS "${LIBTORRENT_DIR_MESSAGE}")
  ELSE(NOT LIBTORRENT_FIND_QUIETLY)
    IF(LIBTORRENT_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "${LIBTORRENT_DIR_MESSAGE}")
    ENDIF(LIBTORRENT_FIND_REQUIRED)
  ENDIF(NOT LIBTORRENT_FIND_QUIETLY)
ENDIF(NOT LIBTORRENT_FOUND)


